/*Initialize a HSHContext*/
function HSHInit()
{
	HSHContext = new Array();
	HSHContext[0] = 1078530011;
	HSHContext[1] = 0;
	return HSHContext;
}

/*Feed HSH context with raw input*/
function HSHRawInput(context, keyunit)
{
	var i;
	HSHContext[1] ^= keyunit;
	for(i = 0; i < 7; i++)
	{
		HSHContext[0] = rotate_left(HSHContext[0], 11);
		HSHContext[1] = rotate_left(HSHContext[1], 13);
		HSHContext[1] ^= HSHContext[0];
		HSHContext[1] = rotate_left(HSHContext[1], HSHContext[0] % 32);
		HSHContext[0] = rotate_left(HSHContext[0], HSHContext[1] % 32);
	}
	return HSHContext;
}

/*Feed HSH context with string input*/
function HSHStrInput(context, key)
{
	var i;
	var keyunit;
	for(i=0; i < Math.ceil(key.length/4); i++)
	{
		keyunit = 0;
		if(key.length > i*4)	
			keyunit += Math.pow(2,24)*key.charCodeAt(i*4);
		if(key.length > i*4+1)	
			keyunit += Math.pow(2,16)*key.charCodeAt(i*4+1);
		if(key.length > i*4+2)	
			keyunit += Math.pow(2,8)*key.charCodeAt(i*4+2);
		if(key.length > i*4+3)
			keyunit += key.charCodeAt(i*4+3);
		context = HSHRawInput(context, keyunit);
	}
	return context;
}

/*Get result from HSH context*/
function HSHResult(context)
{
	return (context[1] >>> 0).toString(16);
}

/*Reset HSH context*/
function HSHReset()
{
	return HSHInit();
}


//Bitwise rotation to the left, of a 32-bit integer
function rotate_left(value, places)
{
	return (value << places) | (value >>> (32 - places));
}
